package com.example.fuzzControll.controller.dataController;

import com.example.fuzzControll.domain.bo.CmdStartParams;
import com.example.fuzzControll.domain.bo.TestEntity;
import com.example.fuzzControll.domain.po.TestAndParams;
import com.example.fuzzControll.domain.vo.AjaxResult;
import com.example.fuzzControll.exception.testException.CmdException;
import com.example.fuzzControll.service.SeedFileService;
import com.example.fuzzControll.service.TestMissionService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 测试信息控制栏
 */
@Slf4j
@RestController
@RequestMapping("/testmission")
public class TestMissionController {
    @Autowired
    TestMissionService testMissionService;

    /**
     * 测试信息获取
     */
    @RequestMapping(value = "/getAll", method = RequestMethod.GET)
    public AjaxResult getTestAndParamsList() {
        List<TestAndParams> testAndParamsList = null;
        try {
            testAndParamsList = testMissionService.getTestAndParamsList();
        } catch (Exception e) {
            return AjaxResult.error();
        }
        return AjaxResult.success(testAndParamsList);
    }

    /**
     * 测试信息删除
     */
    @RequestMapping(value = "/deleteById", method = RequestMethod.GET)
    public AjaxResult deleteById(@RequestParam int id) {
        boolean flag = false;
        try {
            flag = testMissionService.deleteById(id);
            if (!flag) {
                throw new RuntimeException();
            }
        } catch (Exception e) {
            return AjaxResult.error("删除失败！");
        }
        return AjaxResult.success("删除成功！");
    }

    /**
     * 新建测试
     */
    @RequestMapping(value = "/insert", method = RequestMethod.GET)
    public AjaxResult insert(@RequestParam String testname) {
        TestAndParams testAndParams = new TestAndParams(testname);
        try {
            testMissionService.insert(testAndParams);
        } catch (Exception e) {
            return AjaxResult.error("新建失败！");
        }
        return AjaxResult.success("新建成功！");
    }

    /**
     * 给空白测试配置参数
     */
    @RequestMapping(value = "/insertWithAflnet/{id}", method = RequestMethod.POST)
    public AjaxResult insertParmasInTestAflnet(@PathVariable("id")int id,@RequestBody final CmdStartParams cmdStartParams) {
        try {
            testMissionService.insertParmasInTestAflnet(id,cmdStartParams);
        } catch (Exception e) {
            return AjaxResult.error("参数配置失败！");
        }
        return AjaxResult.success("参数配置成功！");
    }

    @RequestMapping(value = "/insertWithkitty/{id}", method = RequestMethod.POST)
    public AjaxResult insertParmasInTestKitty(@PathVariable("id")int id,@RequestBody TestEntity testEntity) {
        try {
            testMissionService.insertParmasInTestKitty(id,testEntity);
        } catch (Exception e) {
            return AjaxResult.error("参数配置失败！");
        }
        return AjaxResult.success("参数配置成功！");
    }
}
